# gtpl

This project was generated using [Nx](https:# nx.dev).

<p align="center"><img src="https:# raw.githubusercontent.com/nrwl/nx/master/images/nx-logo.png" width="450"></p>

🔎 **Nx is a set of Extensible Dev Tools for Monorepos.**

## Adding capabilities to your workspace

Nx supports many plugins which add capabilities for developing different types of applications and different tools.

These capabilities include generating applications, libraries, etc as well as the devtools to test, and build projects as well.

Below are our core plugins:

- [React](https:# reactjs.org)
  - `npm install --save-dev @nrwl/react`
- Web (no framework frontends)
  - `npm install --save-dev @nrwl/web`
- [Angular](https:# angular.io)
  - `npm install --save-dev @nrwl/angular`
- [Nest](https:# nestjs.com)
  - `npm install --save-dev @nrwl/nest`
- [Express](https:# expressjs.com)
  - `npm install --save-dev @nrwl/express`
- [Node](https:# nodejs.org)
  - `npm install --save-dev @nrwl/node`

There are also many [community plugins](https:# nx.dev/nx-community) you could add.

## Generate an application

Run `nx g @nrwl/react:app my-app` to generate an application.

> You can use any of the plugins above to generate applications as well.

When using Nx, you can create multiple applications and libraries in the same workspace.

## Generate a library

Run `nx g @nrwl/react:lib my-lib` to generate a library.

> You can also use any of the plugins above to generate libraries as well.

Libraries are sharable across libraries and applications. They can be imported from `@gtpl/mylib`.

## Development server

Run `nx serve my-app` for a dev server. Navigate to http:# localhost:4200/. The app will automatically reload if you change any of the source files.

## Code scaffolding

Run `nx g @nrwl/react:component my-component --project=my-app` to generate a new component.

## Build

Run `nx build my-app` to build the project. The build artifacts will be stored in the `dist/` directory. Use the `--prod` flag for a production build.

## Running unit tests

Run `nx test my-app` to execute the unit tests via [Jest](https:# jestjs.io).

Run `nx affected:test` to execute the unit tests affected by a change.

## Running end-to-end tests

Run `ng e2e my-app` to execute the end-to-end tests via [Cypress](https:# www.cypress.io).

Run `nx affected:e2e` to execute the end-to-end tests affected by a change.

## Understand your workspace

Run `nx dep-graph` to see a diagram of the dependencies of your projects.

## Further help

Visit the [Nx Documentation](https:# nx.dev) to learn more.

## ☁ Nx Cloud

### Computation Memoization in the Cloud

<p align="center"><img src="https:# raw.githubusercontent.com/nrwl/nx/master/images/nx-cloud-card.png"></p>

Nx Cloud pairs with Nx in order to enable you to build and test code more rapidly, by up to 10 times. Even teams that are new to Nx can connect to Nx Cloud and start saving time instantly.

Teams using Nx gain the advantage of building full-stack applications with their preferred framework alongside Nx’s advanced code generation and project dependency graph, plus a unified experience for both frontend and backend developers.

Visit [Nx Cloud](https:# nx.app/) to learn more.
# Commands used for Backend
#  Install nest-app dependencies
npm install -D @nrwl/nest
#  Create folder under apps directory
#  Create nest js project (for the latest version use generate)
nx generate @nrwl/nest:application services/hrms <nest-app>
			or
nx g @nrwl/nest:application hrms		
nx run services-hrms:serve
npm install --save @nestjs/swagger swagger-ui-express
# Change the content in Main.ts file according to the swagger documentation
# Ref url : https:# docs.nestjs.com/openapi/introduction
# Create nest module
nx generate @nestjs/schematics:module --name=holidays --sourceRoot=apps/services/gtpl-backend/src/app
# Create nest controller
nx generate @nestjs/schematics:controller --name=Districts --module=districts --sourceRoot=apps/services/gtpl-backend/src/app 
nx generate @nestjs/schematics:controller --name=Holidays --module=holidays --sourceRoot=apps/services/gtpl-backend/src/app
or
nx generate @nestjs/schematics:controller --name=Holidays --sourceRoot=apps/services/backend/src/app
or
nx generate @nestjs/schematics:controller --name=adds --sourceRoot=apps/services/backend/src/app
# Create nest service
nx generate @nestjs/schematics:service --name=holidays --module=holiday --sourceRoot=apps/services/gtpl-backend/src/app
or
nx generate @nestjs/schematics:service --name=adds  --sourceRoot=apps/services/backend/src/app 
# Libraries creation
npx nx g @nrwl/workspace:library gtpl --directory shared-services
npx nx g @nrwl/workspace:library gtpl --directory shared-models
npx nx g @nrwl/workspace:library common-models --directory shared-models
npx nx g @nrwl/workspace:library error-messages --directory shared-utils

# Commands used for Frontend
# Install React Dependencies
npm install -D @nrwl/react
# Create Project
nx generate @nrwl/react:application ui/attendance
# Install antd
npm i antd
# Generate pages in Libs folder
nx g @nrwl/react:lib attendance-management/attendance-management-pages/states-pages --directory pages
nx g @nrwl/react:lib attendance-management/attendance-management-components/states-grid --directory pages
nx g @nrwl/react:lib attendance-management/attendance-management-components/states-form --directory pages
# run
nx run services-backend:serve
