import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn} from "typeorm";
import { RoleActivityEntity } from "../role-activity/role-activity.entity";

@Entity('activity')
export class ActivityEntity {
  
  @PrimaryGeneratedColumn("increment",{name:'id'})
  Id:number;
  @Column("int",{
    nullable:false,
    name:"activity_id"
  })
  activityId:number;
  @Column("varchar",{
    nullable:false,
    length:500,
    name:"activity_name"
  })
  activityName:string;
  @Column("varchar",{
    nullable: true,
    length:500,
    name:"activity_url"
  })
  activityUrl:string; 
  @Column("boolean",{
    nullable:false,
    default:true,               
    name:"status"
  })
  status:boolean;
  @CreateDateColumn({
    name: "created_at",
    type:"datetime"
  })
  createdAt: Date;
  @Column("int", {
      nullable: true,
      name: "created_user"
  })
  createdUser: number | null;
  @UpdateDateColumn({
      name: "updated_at",
      type:'datetime'
  })
  updatedAt: Date;
  @Column("int", {
      nullable: true,
      name: "updated_user"
  })
  updatedUser: number | null;
  @VersionColumn({
      default:1,
      name: "version_flag"
  })
  versionFlag: number;
  @OneToMany(() => RoleActivityEntity, (roleActivity: RoleActivityEntity) => roleActivity.activity)
  roleActivity: RoleActivityEntity;  
}
