import { forwardRef, Module } from '@nestjs/common';
import { ActivityController } from './activity.controller';
import { ActivityEntity } from './activity.entity';
import { ActivityService } from './activity.service';
import { TypeOrmModule } from '@nestjs/typeorm';
import { RoleActivityModule } from '../role-activity/role-activity.module';

@Module({
  imports: [
    TypeOrmModule.forFeature([ActivityEntity]),
    forwardRef(() => RoleActivityModule),
  ],
  controllers: [ActivityController],
  providers: [ActivityService],
  exports: [ActivityService]
})
export class ActivityModule {}




