import {IsInt, IsEmail, IsString, IsDateString, IsNumber, IsDate,IsAlphanumeric, MaxLength, Matches, IsOptional, IsNotEmpty, ValidateNested, isNotEmpty } from 'class-validator';
import { ApiProperty } from '@nestjs/swagger';

export class ActivityDTO {
  @ApiProperty()
  @IsOptional()
  Id?: number;
  @ApiProperty()
  activityId:number;
  @ApiProperty()
  @IsNotEmpty({message:"activity name should not be empty"})
  @MaxLength(500, { message: "activity name allows 500 characters only. " })
  @Matches(new RegExp("^[a-zA-Z0-9\\s]+$"),{ message:"activity name should be only alpha numeric" })
  activityName:string;
  @ApiProperty()
  activityUrl:string;
  @ApiProperty()
  status: boolean;
  createdAt : Date;
  @ApiProperty()
  @IsOptional()
  createdUser : number;
  updatedAt : Date;
  @ApiProperty()
  @IsOptional()
  updatedUser : number;
  @ApiProperty()
  versionFlag : number;
  @ApiProperty({type:[String]})
  roleIds?:string[];
}
export class ActivityStatusDTO{
  @ApiProperty()
  Id: number;
  @ApiProperty()
  status: boolean;
  updatedAt : Date;
  @ApiProperty()
  @IsOptional()
  updatedUser : number;
  @ApiProperty()
  versionFlag : number;
}