import { forwardRef, Module } from '@nestjs/common';
import { TypeOrmModule } from '@nestjs/typeorm';
import { ProfileModule } from '../profile/profile.module';
import { CMRFController } from './cmrf.controller';
import { CMRFEntity } from './cmrf.entity';
import { CMRFService } from './cmrf.service';
@Module({
  imports: [
    TypeOrmModule.forFeature([CMRFEntity]),
    forwardRef(()=>ProfileModule),
  ],
  controllers: [CMRFController],
  providers: [CMRFService],
  exports:[CMRFService]
})
export class CMRFModule {}
