import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn,BeforeInsert, BeforeUpdate} from "typeorm";
import { PostEntity } from '../post/post.entity';
import { ReportEntity } from "../report/report.entity";
import { UserEntity } from "../user/user.entity";
@Entity('comments')

export class CommmentsEntity {

    @PrimaryGeneratedColumn('increment',{name:'id'}) Id: number;
    @Column({
        type: 'int',
        nullable: false,
        name:'post_id',
    })
    postId: number;
    @Column({
        type:"int",
        nullable:false,
        name:"user_id"
    })
    userId:number;
    @Column({
        type: 'varchar',
        nullable: false,
        length: '500',
        name: 'comment',
    })
    comment: string;
    @Column("boolean",{
        nullable:false,
        default:true,               
        name:"status"
    })
    status:boolean;
    @CreateDateColumn({
        name: "created_at",
        type:"datetime"
    })
    createdAt: Date;
    @Column("int", {
        nullable: true,
        name: "created_user"
    })
    createdUser: number | null;
    @UpdateDateColumn({
        name: "updated_at",
        type:'datetime'
    })
    updatedAt: Date;
    @Column("int", {
        nullable: true,
        name: "updated_user"
    })
    updatedUser: number | null;
    @VersionColumn({
        default:1,
        name: "version_flag"
    })
    versionFlag: number;
   
    @ManyToOne(() => PostEntity, (post: PostEntity) => post.comments)
    @JoinColumn({ name: 'post_id' })
    post: PostEntity;
    @ManyToOne(() => UserEntity, (user:UserEntity) => user.comments)
    @JoinColumn({ name:"user_id" })
    user: UserEntity;
    @OneToMany(() => ReportEntity, (report: ReportEntity) => report.comments)
    report: ReportEntity;
}