import {IsInt, IsEmail, IsString, IsDateString, IsNumber, IsDate,IsAlphanumeric, MaxLength, Matches, IsOptional, IsNotEmpty, ValidateNested, isNotEmpty } from 'class-validator';
import { ApiProperty } from '@nestjs/swagger';

export class CommentsDTO {
  @ApiProperty()
  @IsOptional()
  Id?: number;
  @ApiProperty()
  @IsNotEmpty({message:"Post id should not be empty"})
  postId:number;
  @ApiProperty()
  @IsNotEmpty({message:"Usre id should not be empty"})
  userId:number;
  @ApiProperty()
  @MaxLength(500, { message: "Comment Code allows maximum 255 characters" })
  comment:string;
  @ApiProperty()
  status: boolean;
  createdAt : Date;
  @ApiProperty()
  @IsOptional()
  createdUser : number;
  updatedAt : Date;
  @ApiProperty()
  @IsOptional()
  updatedUser : number;
  @ApiProperty()
  versionFlag : number;
}


export class GetCommentsByPostId {
  @ApiProperty()
  @IsNotEmpty()
  postId:number;
}

export class PaginationDto {
  @ApiProperty()
  apiVersion?:number;
  @ApiProperty()
  skip:number;
 
}
export class DeletDto {
  @ApiProperty()
  @IsNotEmpty()
  Id:number;
}
