import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn,BeforeInsert, BeforeUpdate} from "typeorm";
import { ComplaintEntity } from "./complaint.entity";


@Entity('complaint_type')
export class ComplaintTypeEntity { 

    @PrimaryGeneratedColumn('increment',{name:'id'}) 
    Id: number; 
    @Column("varchar",{
        nullable:false,
        length:500,
        name:"type"
    })
    type:string; 
    @Column("varchar",{
        nullable:true,
        name:"img_url"
    })
    imageUrl:string;
    @Column("boolean",{
        nullable:false,
        default:true,               
        name:"status"
    })
    status:boolean;  
    @CreateDateColumn({
        name: "created_at",
        type:"datetime"
    })
    createdAt: Date;
    @Column("int", {
        nullable: true,
        name: "created_user"
    })
    createdUser: number | null;
    @UpdateDateColumn({
        name: "updated_at",
        type:'datetime'
    })
    updatedAt: Date;
    @Column("int", {
        nullable: true,
        name: "updated_user"
    })
    updatedUser: number | null;
    @VersionColumn({
        default:1,
        name: "version_flag"
    })
    versionFlag: number;
    @OneToMany(() =>ComplaintEntity,(complaint:ComplaintEntity)=>complaint.complaintype)
    complaint:ComplaintEntity; 
   
}