import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn,BeforeInsert, BeforeUpdate} from "typeorm";
import { UserEntity } from "../user/user.entity";
import { ComplaintFilesEntity } from "./complaint-files.entity";
import { ComplaintTypeEntity } from "./complaint-type.entity";
import { ComplaintStatusEntity } from "./status-details.entity";

@Entity('complaint')
export class ComplaintEntity { 

    @PrimaryGeneratedColumn('increment',{name:'id'}) 
    Id: number; 
    @Column("int",{
        nullable:false,
        name:"type_id"
    })
    complaintTypeId:number;
    @Column("varchar",{
        nullable:true,
        length:500,
        name:"text"
    })
    text:string; 
    @Column("varchar",{
        nullable:false,
        length:100,
        name:"first_name"
    })
    firstName:string; 
    @Column("varchar",{
        nullable:true,
        length:100,
        name:"last_name"
    })
    lastName:string;
    @Column("varchar",{
        nullable:true,
        length:100,
        name:"address"
    })
    address:string;
    @Column({
        type: 'int',
        nullable:true,
        name: 'village_id'
    })
    villageId: number;
    @Column("varchar",{
        nullable:false,
        length:10,
        name:"mobileNo"
    })
    mobileNo:string;
    @Column("varchar",{
        nullable: false,
        length:250,
        name:"email"
      })
      email:string;
      @Column("varchar",{
        nullable: false,
        length:250,
        name:"complaint_status"
      })
      complaintStatus:string;
      @Column({
        type: 'int',
        nullable:true,
        name: 'user_id'
    })
    userId: number;
      @Column("boolean",{
        nullable:false,
        default:true,               
        name:"status"
    })
    status:boolean;
  
    @CreateDateColumn({
        name: "created_at",
        type:"datetime"
    })
    createdAt: Date;
    @Column("int", {
        nullable: true,
        name: "created_user"
    })
    createdUser: number | null;
    @UpdateDateColumn({
        name: "updated_at",
        type:'datetime'
    })
    updatedAt: Date;
    @Column("int", {
        nullable: true,
        name: "updated_user"
    })
    updatedUser: number | null;
    @VersionColumn({
        default:1,
        name: "version_flag"
    })
    versionFlag: number;
    @ManyToOne(() =>ComplaintTypeEntity,(complaintype:ComplaintTypeEntity)=>complaintype.complaint)
    @JoinColumn({name:"type_id"})
    complaintype:ComplaintTypeEntity;
    @ManyToOne(() =>UserEntity,(user:UserEntity)=>user.complaint)
    @JoinColumn({name:"user_id"})
    user:UserEntity;
    @OneToMany(() =>ComplaintFilesEntity,(complaintfiles:ComplaintFilesEntity)=>complaintfiles.complaint)
    complaintfiles:ComplaintFilesEntity;
    @OneToMany(() =>ComplaintStatusEntity,(complaintstatus:ComplaintStatusEntity)=>complaintstatus.complaint)
    complaintstatus:ComplaintStatusEntity;
}