import {IsInt, IsEmail, IsString, IsDateString, IsNumber, IsDate,IsAlphanumeric, MaxLength, Matches, IsOptional, IsNotEmpty, ValidateNested, isNotEmpty } from 'class-validator';
import { ApiProperty, ApiPropertyOptional } from '@nestjs/swagger';


export class CTypeDTO {
  @ApiProperty()
  @ApiPropertyOptional()
  Id?: number;
  @ApiProperty()
  type:string;
  @ApiProperty()
  @ApiPropertyOptional()
  imageUrl?:string;
  @ApiProperty({ type: 'array', items: { type: 'string', format: 'binary' } })
  @ApiPropertyOptional()
  attachments?:string;
  @ApiProperty()
  @ApiPropertyOptional()
  status: boolean;
  createdAt : Date;
  @ApiProperty()
  @IsOptional()
  @ApiPropertyOptional()
  createdUser : number;
  updatedAt : Date;
  @ApiProperty()
  @IsOptional()
  @ApiPropertyOptional()
  updatedUser : number;
  @ApiProperty()
  @ApiPropertyOptional()
  versionFlag : number;
}

export class DelTypeDTO {
  @ApiProperty()
  Id: number;
  @ApiProperty()
  status: boolean;
  @ApiProperty()
  @ApiPropertyOptional()
  updatedUser: number;
}

export class ComplaintDTO {

  @ApiProperty()
  @ApiPropertyOptional()
  Id?: number;
  @ApiProperty()
  complaintTypeId?: number;
  @ApiProperty()
  @ApiPropertyOptional()
  text:string;
  @ApiProperty()
  firstName:string;
  @ApiProperty()
  @ApiPropertyOptional()
  lastName:string;
  @ApiProperty()
  @ApiPropertyOptional()
  address:string;
  @ApiProperty()
  @ApiPropertyOptional()
  villageId:number;
  @ApiProperty()
  @ApiPropertyOptional()
  @MaxLength(10, { message: "Mobile number allows 10 characters only. " })
  mobileNo:string;
  @ApiProperty()
  @ApiPropertyOptional() 
  email: string;
  @ApiProperty()
  @ApiPropertyOptional()
  complaintStatus:string;
  @ApiProperty()
  userId:number;
  @ApiProperty({ type: 'array', items: { type: 'string', format: 'binary' } })
  @ApiPropertyOptional()
  attachments?:string;
  @ApiProperty()
  @ApiPropertyOptional()
  status: boolean;
  createdAt : Date;
  @ApiProperty()
  @IsOptional()
  @ApiPropertyOptional()
  createdUser : number;
  updatedAt : Date;
  @ApiProperty()
  @IsOptional()
  @ApiPropertyOptional()
  updatedUser : number;
  @ApiProperty()
  @ApiPropertyOptional()
  versionFlag : number;
}

export class ChangeStatusDTO {
  @ApiProperty()
  Id: number;
  @ApiProperty()
  complaintStatus:string;
  @ApiProperty()
  updatedUser:number;
}


export class ComplaintDelDTO {
    @ApiProperty()
    Id: number;
    @ApiProperty()
    status: boolean;
    updatedAt : Date;
    @ApiProperty()
    updatedUser : number;
    @ApiProperty()
    versionFlag : number;
  }
