import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn,BeforeInsert, BeforeUpdate} from "typeorm";
import { ComplaintEntity } from "./complaint.entity";

@Entity('complaint_status')
export class ComplaintStatusEntity { 

    @PrimaryGeneratedColumn('increment',{name:'id'}) 
    Id: number; 
   
    @Column({
        type: 'int',
        nullable:false,
        name: 'complaint_id'
    })
    complaintId: number;
      @Column("varchar",{
        nullable: true,
        length:500,
        name:"status"
      })
      status:string;
      @Column("boolean",{
        nullable:false,
        default:true,               
        name:"is_active"
    })
    isActive:boolean;
      @CreateDateColumn({
        name: "created_at",
        type:"datetime"
    })
    createdAt: Date;
    @Column("int", {
        nullable: true,
        name: "created_user"
    })
    createdUser: number | null;
    @ManyToOne(() =>ComplaintEntity,(complaint:ComplaintEntity)=>complaint.complaintstatus)
    @JoinColumn({name:"complaint_id"})
    complaint:ComplaintEntity;
   
}