import { ErrorResponse } from '@gtpl/shared-models/common-models';
import { Injectable } from '@nestjs/common';
import { InjectRepository } from '@nestjs/typeorm';
import { Repository } from 'typeorm';
import { PostEntity } from '../post/post.entity';
import { DevelopmentStatusEntity } from './developmentpost.entity';
import { developmentResponseModel, } from './dto/developmentpost-response-module';
import { developmentpoststatusupdateDTO,  } from './dto/developmentpost.dto';

@Injectable()
export class DevelopmentpostService {

    constructor(
      
        @InjectRepository(DevelopmentStatusEntity)
        private developmentpostRepository: Repository<DevelopmentStatusEntity>,
        @InjectRepository(PostEntity)
        private postRepo:Repository<PostEntity>,
    ) {}

    
    async updatedevelopmentstatus(queryParams, developmentpoststatusupdateDTO: developmentpoststatusupdateDTO, request:Request): Promise<developmentResponseModel> {
        const response = new developmentResponseModel();      
        try {
            await this.developmentpostRepository.update({
                postId:developmentpoststatusupdateDTO.postId   
            },{status:false})
            if(queryParams.apiVersion == 1) {
                const newOne = await this.developmentpostRepository.save({
                    postId:developmentpoststatusupdateDTO.postId,
                    developmentStatus:developmentpoststatusupdateDTO.developmentStatus,
                    createdUser:developmentpoststatusupdateDTO.createdUser
                })
                const updatedData = await this.developmentpostRepository.findOne({
                    relations:['post'],
                    where:{postId:developmentpoststatusupdateDTO.postId,Id:newOne.Id}
                });
                if(newOne) {
                    const pnew = await this.postRepo.update(developmentpoststatusupdateDTO.postId,{developStatus:developmentpoststatusupdateDTO.developmentStatus})
                    response.status = true;
                    response.data = updatedData;
                    response.statusCode = 50000;
                    response.internalMessage = 'development post status updated successfully';
                    response.intlCode = 11108;
                } else {
                    throw new ErrorResponse(99998, 'development post status Update Failed')
                }
            } else {
                const newOne = await this.developmentpostRepository.save({
                    postId:developmentpoststatusupdateDTO.postId,
                    developmentStatus:developmentpoststatusupdateDTO.developmentStatus,
                    createdUser:developmentpoststatusupdateDTO.createdUser
                })
                const updatedData = await this.developmentpostRepository.findOne({
                    relations:['post'],
                    where:{postId:developmentpoststatusupdateDTO.postId,Id:newOne.Id}
                });
                if(newOne) {
                    const pnew = await this.postRepo.update(developmentpoststatusupdateDTO.postId,{developStatus:developmentpoststatusupdateDTO.developmentStatus})
                    response.status = true;
                    response.data = updatedData;
                    response.statusCode = 50000;
                    response.internalMessage = 'development post status updated successfully';
                    response.intlCode = 11108;
                } else {
                    throw new ErrorResponse(99998, 'development post status Update Failed')
                }
            }
          return response;
        } catch (error) {
            throw error;
        }
    }

    
}
