import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn} from "typeorm";
import { MandalEntity } from "../mandal/mandal.entity";
import { VillageEntity } from "../village/village.entity";
import {StatesEntity} from "../states/states.entity";

@Entity('district')
export class DistrictEntity{

    @PrimaryGeneratedColumn("increment",{name:'id'})
    Id:number;
    @Column("char",{
        nullable:true,
        length:5,
        name:"district_code"
    })
    @Index({unique:true})
    districtCode:string;
    @Column("varchar",{
        nullable:false,
        length:500,
        name:"district_name"
    })
    districtName:string; 
    @Column("int",{
        nullable:false,
        name:"state_id"
    })
    stateId: number;
    @Column("boolean",{
        nullable:false,
        default:true,
        name:"status"
    })
    status:boolean;
    @CreateDateColumn({
        name: "created_at",
        type:"datetime"
    })
    createdAt: Date;
    @Column("int",{
        nullable:true,
        name:"created_user"
    })
    createdUser:number| null;
    @UpdateDateColumn({
        name: "updated_at",
        type:'datetime'
    })
    updatedAt:Date;
    @Column("int",{
        nullable:true,
        name: "updated_user"
    })
    updatedUser: number| null;
    @VersionColumn({
        default:1,
        name: "version_flag"
    })
    versionFlag: number;
  
    @ManyToOne(() => StatesEntity, (states:StatesEntity) => states.district)
    @JoinColumn({ name: 'state_id'})
    states: StatesEntity;

    @OneToMany(() => MandalEntity,(mandal: MandalEntity)=> mandal.district)
    mandal: MandalEntity;

    // @OneToMany(() => VillageEntity,(village: VillageEntity) => village.district)
    // village: VillageEntity;
}
