import {IsInt, IsEmail, IsString, IsDateString, IsNumber, IsDate,IsAlphanumeric, MaxLength, Matches, IsOptional, IsNotEmpty, ValidateNested, isNotEmpty } from 'class-validator';
import { ApiProperty } from '@nestjs/swagger';

export class DistrictDTO {    
    @ApiProperty()
    @IsOptional()
    Id?: number;
    @ApiProperty()
    districtCode:string;
    @ApiProperty()
    @IsNotEmpty()
    @MaxLength(500,{ message: "District name not empty"})
    districtName:string;
    @ApiProperty()
    @IsNotEmpty()
    stateId:number;
    @ApiProperty()
    status: boolean;
    createdAt : Date;
    @ApiProperty()
    @IsOptional()
    createdUser : number;
    updatedAt : Date;
    @ApiProperty()
    @IsOptional()
    updatedUser : number;
    @ApiProperty()
    versionFlag : number;
}

export class DistrictStatusDTO {
    @ApiProperty()
    @IsOptional()
    Id?: number;
    @ApiProperty()
    status: boolean;
    updatedAt : Date;
    @ApiProperty()
    @IsOptional()
    updatedUser : number;
}
export class getstatesDTO {
  
    @ApiProperty()
    @IsNotEmpty({message:"stateId should not be empty"})
    stateId:number;
    
  }