import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn,BeforeInsert, BeforeUpdate} from "typeorm";
import { EventsEntity } from '../event/event.entity';
import { ReportEntity } from "../report/report.entity";
import { UserEntity } from "../user/user.entity";

@Entity('event_details')
export class EventDetailsEntity {

    @PrimaryGeneratedColumn('increment',{name:'id'}) Id: number;   
    @Column("int",{
        nullable: false,
        name:"guest_id"
    })
    guestId:number;
    @Column("int",{
        nullable: false,
        name:"event_id"
    })
    eventId:number;   
    @Column("boolean",{
        nullable:false,
        default:true,               
        name:"status"
    })
    status:boolean;
    @CreateDateColumn({
        name: "created_at",
        type:"datetime"
    })
    createdAt: Date;
    @Column("int", {
        nullable: true,
        name: "created_user"
    })
    createdUser: number | null;
    @VersionColumn({
        default:1,
        name: "version_flag"
    })
    versionFlag: number;   
    
    @ManyToOne(() => UserEntity, (user:UserEntity) => user.eventdetails)
    @JoinColumn({ name:"guest_id" })
    user: UserEntity;
    @ManyToOne(() => EventsEntity, (event:EventsEntity) => event.eventdetails)
    @JoinColumn({ name:"event_id" })
    event: EventsEntity;
}