import { Injectable } from '@nestjs/common';
import { InjectRepository } from '@nestjs/typeorm';
import { Repository } from 'typeorm';
import { EventDetailsEntity } from './event-details.entity';

@Injectable()
export class EventDetailsService {
    constructor(
        @InjectRepository(EventDetailsEntity)
        private eventDetailsRepo:Repository<EventDetailsEntity>,
        
    ){}

    async createGuestUsers(dataToPost) {
        console.log(dataToPost)
        const saveData = await this.eventDetailsRepo.save(dataToPost);
        console.log(saveData)
        if(saveData) {
            return true;
        } else {
            return null;
        }
    }

    async deleteGuestUsers(eventId) {
        const del = await this.eventDetailsRepo.delete({eventId:eventId})
        if(del) {
            return true;
        } else {
            return null;
        }
    }

    async checkGuestUser(userId,eventId) {
        const data = await this.eventDetailsRepo.findOne({
            where:{eventId:eventId,guestId:userId}
        })
        if(data) {
            return data;
        } else {
            return null;
        }
    }

    async GuestUserCount(eventId) {
        const data = await this.eventDetailsRepo.find({
            where:{eventId:eventId,status:true}
        })
        if(data) {
            return data;
        } else {
            return null;
        }
    }
}
