import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn} from "typeorm";
import { UserEntity } from "../user/user.entity";
import { EventsEntity } from "./event.entity";

@Entity('event_rsvp')
export class EventRSVPEntity {
  
  @PrimaryGeneratedColumn("increment",{name:'id'})
  Id:number;
  @Column("int",{
    nullable:false,
    name:"event_id"
  })
  eventId:number;
  @Column("int",{
    nullable:false,
    name:"user_id"
  })
  userId:number;
  @Column("int",{
    nullable:false,             
    name:"rsvp"
  })
  rsvp:number;
  
  @ManyToOne(() => EventsEntity, (event: EventsEntity) => event.eventrsvp)
  @JoinColumn({ name: 'event_id' })
  event: EventsEntity;
  @ManyToOne(() => UserEntity, (user: UserEntity) => user.eventrsvp)
  @JoinColumn({name: 'user_id'})
  user: UserEntity;
}