import { forwardRef, Module } from '@nestjs/common';
import { TypeOrmModule } from '@nestjs/typeorm';
import { EventDetailsModule } from '../event-details/event-details.module';
import { NotificationsEntity } from '../notifications/notifications.entity';
import { PostEntity } from '../post/post.entity';
import { ProfileEntity } from '../profile/profile.entity';
import { UserEntity } from '../user/user.entity';
import { EventFilesEntity } from './event-files.entity';
import { EventRSVPEntity } from './event-rsvp.entity';
import { EventController } from './event.controller';
import { EventsEntity } from './event.entity';
import { EventService } from './event.service';

@Module({
    imports: [
        TypeOrmModule.forFeature([EventsEntity,EventFilesEntity,ProfileEntity,EventRSVPEntity,NotificationsEntity,UserEntity,PostEntity]),
        forwardRef(() =>EventDetailsModule),
    ],
    controllers:[EventController],
    providers:[EventService],
    exports:[EventService],
})
export class EventsModule {}