import {IsInt, IsEmail, IsString, IsDateString, IsNumber, IsDate,IsAlphanumeric, MaxLength, Matches, IsOptional, IsNotEmpty, ValidateNested, isNotEmpty } from 'class-validator';
import { ApiProperty } from '@nestjs/swagger';

export class EventcategoryDTO {
  @ApiProperty()
  @IsOptional()
  Id?: number;
 
  @ApiProperty()
  @MaxLength(500, { message: "category Code allows maximum 500 characters" })
  category:string;
  @ApiProperty()
  status: boolean;
 
  @ApiProperty()
 
  createdAt : Date;
  @ApiProperty()
  @IsOptional()
  createdUser : number;
  updatedAt : Date;
  @ApiProperty()
  @IsOptional()
  updatedUser : number;
  @ApiProperty()
  versionFlag : number;
}



export class EventcategoryStatusDTO {
  @ApiProperty()
  @IsNotEmpty({message:"Id should not be empty"})
  @IsNumber()
  Id: number;
  @ApiProperty()
  status: boolean;
  updatedAt : Date;
  @ApiProperty()
  @IsOptional()
  updatedUser : number;
}

export class GetEventcategoryDTO {
  @ApiProperty()
  @IsNotEmpty({message:"Id should not be empty"})    
  Id:number;   
}