import { errorHandler } from '@gtpl/shared-utils/error-messages';
import { Body, Controller, Get, Post, Query, Req } from '@nestjs/common';
import { ApiHeader, ApiQuery, ApiTags } from '@nestjs/swagger';
import { EventcategoryDTO, EventcategoryStatusDTO } from './dto/eventcategory.dto';
import { AllEventcategoryResponseModel, EventcategoryResponseModel } from './eventcategory-respone-module';
import { EventcategoryService } from './eventcategory.service';
@ApiTags('eventcategory')
@Controller('eventcategory')
export class EventcategoryController {


    constructor (
        private EventcategoryService:EventcategoryService
    ) {}
    @ApiHeader({
        name:'Authorization',
        description:'Authorization token'
    })
    @Post('/createEventcategory')
    @ApiQuery({name:'apiVersion'})
    async createEventcategory(@Query() queryParams, @Body() EventcategoryDTO:EventcategoryDTO, @Req() request: Request): Promise<EventcategoryResponseModel> {
        try {
            return await this.EventcategoryService.createEventcategory(queryParams, EventcategoryDTO, request);
        } catch (error) {
            return errorHandler(EventcategoryResponseModel, error);
        }
    }
    @ApiHeader({
        name:'Authorization',
        description:'Authorization token'
    })
    @Get('/getEventcategory')
    @ApiQuery({name:'apiVersion'})
    async getEventcategory(@Query() queryParams, @Req() request:Request): Promise<AllEventcategoryResponseModel> {
        try {
            return await this.EventcategoryService.getEventcategory(queryParams, request);
        } catch (error) {
            return errorHandler(AllEventcategoryResponseModel, error);
        }
    }
    @ApiHeader({
        name:'Authorization',
        description:'Authorization token'
    })
    @Post('/updateEventcategory')
    @ApiQuery({name:'apiVersion'})
    async updateEventcategory(@Query() queryParams, @Body() EventcategoryDTO:EventcategoryDTO, @Req() request: Request): Promise<EventcategoryResponseModel> {
        try {
            return await this.EventcategoryService.updateEventcategory(queryParams, EventcategoryDTO, request);
        } catch (error) {
            return errorHandler(EventcategoryResponseModel, error);
        }
    }
    @ApiHeader({
        name:'Authorization',
        description:'Authorization token'
    })
    @Post('/updateEventcategoryStatus')
    @ApiQuery({name:'apiVersion'})
    async updateEventcategoryStatus(@Query() queryParams, @Body() EventcategoryStatusDTO:EventcategoryStatusDTO, @Req() request: Request): Promise<EventcategoryResponseModel> {
        try {
            return await this.EventcategoryService.updateEventcategoryStatus(queryParams, EventcategoryStatusDTO, request);
        } catch (error) {
            return errorHandler(EventcategoryResponseModel, error);
        }
    }

}
