import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn,BeforeInsert, BeforeUpdate} from "typeorm";
import { EventDetailsEntity } from "../event-details/event-details.entity";
import { EventsEntity } from "../event/event.entity";
import { UserEntity } from "../user/user.entity";
@Entity('eventcategory')
export class EventscategoryEntity {

    @PrimaryGeneratedColumn('increment',{name:'id'}) Id: number;
    
   
  
    @Column({
        type: 'varchar',
        nullable: false,
        length: '500',
        name: 'category',
    })
    category: string;
   
    @Column("boolean",{
        nullable:false,
        default:true,               
        name:"status"
    })
    status:boolean;
  
    @CreateDateColumn({
        name: "created_at",
        type:"datetime"
    })
    createdAt: Date;
    @Column("int", {
        nullable: true,
        name: "created_user"
    })
    createdUser: number | null;
    @UpdateDateColumn({
        name: "updated_at",
        type:'datetime'
    })
    updatedAt: Date;
    @Column("int", {
        nullable: true,
        name: "updated_user"
    })
    updatedUser: number | null;
    @VersionColumn({
        default:1,
        name: "version_flag"
    })
    versionFlag: number;   


    @OneToMany(()=>EventsEntity, (event:EventsEntity)=>event.eventcategory)
    event:EventsEntity;
}