import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn,BeforeInsert, BeforeUpdate} from "typeorm";
import { UserEntity } from "../user/user.entity";

@Entity('feedback')
export class FeedBackEntity {

    @PrimaryGeneratedColumn('increment',{name:'id'}) Id: number;
    @Column({
        type: 'varchar',
        nullable: false,
        length: '500',
        name: 'feedback_title',
    })
    feedBackTitle: string;
    @Column({
        type: 'varchar',
        nullable: false,
        length: '500',
        name: 'feedback_desc',
    })
    feedBackDesc: string;
    @Column("int",{
        nullable:false,
        name:"user_id"
    })
    userId:number;
    @CreateDateColumn({
        name: "created_at",
        type:"datetime"
    })
    createdAt: Date;
    @VersionColumn({
        default:1,
        name: "version_flag"
    })
    versionFlag: number;   
    @ManyToOne(()=>UserEntity, (user:UserEntity)=>user.feedback)
    @JoinColumn({name:"user_id"})
    user:UserEntity;    
}