import { errorHandler } from '@gtpl/shared-utils/error-messages';
import { Body, Controller, Get, Param, Post, Query, Req, Res, UploadedFiles, UseInterceptors } from '@nestjs/common';
import { ApiConsumes, ApiOperation, ApiParam, ApiTags } from '@nestjs/swagger';
import { HamletResponseModel } from './dto/hamlet-response.model';
import { HamletDto } from './dto/hamlet.dto';
import { HamletService } from './hamlet.service';

@ApiTags('Hamlet')
@Controller('hamlet')
export class HamletController {
    constructor (
        private hmService: HamletService
    ) {}

   
    @Post('/save')   
    async create(@Body() sDTO:HamletDto, @Req() request: Request): Promise<HamletResponseModel> {
        try {
            return await this.hmService.createNew(sDTO, request);
        } catch (error) {
            return errorHandler(HamletResponseModel, error);
        }
    }

    @Post('/update')
    async update(@Body() sDTO:HamletDto, @Req() request: Request): Promise<HamletResponseModel> {
        try {
            return await this.hmService.updateOld(sDTO, request);
        } catch (error) {
            return errorHandler(HamletResponseModel, error);
        }
    }


    @Get('/getAll')
    async getdata(@Req() request:Request):Promise<HamletResponseModel> {
        try {
            return await this.hmService.getdata();
        } catch (error) {
            return errorHandler(HamletResponseModel, error);
        }
    }
}


