import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn} from "typeorm";
import { UserEntity } from "../user/user.entity";
@Entity('hierarchy')
export class HierarchyEntity {
  
  @PrimaryGeneratedColumn("increment",{name:'id'})
  Id:number;
  @Column("int",{
    nullable: false,
    name:"nextlevel_loginid"
  })
  nextLevelLoginId:number;
  @Column("int",{
    nullable: false,
    name:"master_loginid"
  })
  masterLoginId:number;
  @Column("boolean",{
    nullable:false,
    default:true,               
    name:"status"
  })
  status:boolean;
  @CreateDateColumn({
    name: "created_at",
    type:"datetime"
  })
  createdAt: Date;
  @Column("int", {
      nullable: true,
      name: "created_user"
  })
  createdUser: number | null;
  @UpdateDateColumn({
      name: "updated_at",
      type:'datetime'
  })
  updatedAt: Date;
  @Column("int", {
      nullable: true,
      name: "updated_user"
  })
  updatedUser: number | null;
  @VersionColumn({
      default:1,
      name: "version_flag"
  })
  versionFlag: number;

  @OneToMany(() => UserEntity, (user: UserEntity) => user.hierarchy)
  user: UserEntity;
}