import { ErrorResponse } from '@gtpl/shared-models/common-models';
import { Injectable } from '@nestjs/common';
import { InjectRepository } from '@nestjs/typeorm';
import { Repository } from 'typeorm';
import { getMyNetworkResponseModel } from '../profile/dto/profile-response-model';
import { ProfileService } from '../profile/profile.service';
import { HierarchyDTO } from './dto/hierarchy.dto';
import { HierarchyEntity } from './hierarchy.entity';


@Injectable()
export class HierarchyService {
    constructor(
        @InjectRepository(HierarchyEntity)
        private hierarchyRespository:Repository<HierarchyEntity>,
        private profileService: ProfileService,
    ){}
    
    async linkHierarchy(hierarchyData) {
        try{
            const savedHierarchy = await this.hierarchyRespository.save(hierarchyData);
            if(savedHierarchy){
                return savedHierarchy;
            } else {
                return null;
            }
        }  catch(error){
            throw error;
        }
    }

    async getMyNetworkByUserId(queryParams, userId, request:Request):Promise<getMyNetworkResponseModel> {
        const response = new getMyNetworkResponseModel();
        try {
            const data = await this.hierarchyRespository.find({
                where:{nextLevelLoginId:userId}
            })
            const finData: any[] = [];
            if(queryParams.apiVersion == 1) {
                if(data) {
                    const promises = data.map(async (lev) => {
                        const userData = await this.profileService.getUserByUId(lev.masterLoginId);
                        if(userData.user.status == true) {
                            return {
                                userId:userData.userId,
                                userName: userData.firstName,
                                profilePic:userData.profilePic,
                                roleId:userData.user.roleId,
                                roleName:userData.user.roles.roleName,
                                mobileNo: userData.mobileNo
                            }
                        }                        
                    });
                    const uda = await Promise.all(promises);
                    uda.map((u) => {
                        if(u != undefined) {
                            finData.push({
                                userId:u.userId,
                                userName:u.userName != null ? u.userName:'',
                                profilePic: u.profilePic != null ? `${process.env.WORKINGURL}/${u.profilePic}` : '',
                                mobileNo:u.mobileNo,
                                roleId:u.roleId,
                                roleName:u.roleName
                            })
                        }
                    })
                    if(finData.length > 0) { 
                        response.status = true;
                        response.data = finData;
                        response.statusCode = 50000;
                        response.internalMessage = 'Data retrieved successfully';
                        response.intlCode = 11108;
                    } else {
                        throw new ErrorResponse(99998, 'Data not found');
                    }
                } else {
                    throw new ErrorResponse(99998, 'Data not found');
                }
            } else {
                if(data) {
                    const promises = data.map(async (lev) => {
                        const userData = await this.profileService.getUserByUId(lev.masterLoginId);
                        if(userData.user.status == true) {
                            return {
                                userId:userData.userId,
                                userName: userData.firstName,
                                profilePic:userData.profilePic,
                                roleId:userData.user.roleId,
                                roleName:userData.user.roles.roleName,
                                mobileNo: userData.mobileNo
                            }
                        }                        
                    });
                    const uda = await Promise.all(promises);
                    uda.map((u) => {
                        if(u != undefined) {
                            finData.push({
                                userId:u.userId,
                                userName:u.userName != null ? u.userName:'',
                                profilePic: u.profilePic != null ? `${process.env.WORKINGURL}/${u.profilePic}` : '',
                                mobileNo:u.mobileNo,
                                roleId:u.roleId,
                                roleName:u.roleName
                            })
                        }
                    })
                    if(finData.length > 0) { 
                        response.status = true;
                        response.data = finData;
                        response.statusCode = 50000;
                        response.internalMessage = 'Data retrieved successfully';
                        response.intlCode = 11108;
                    } else {
                        throw new ErrorResponse(99998, 'Data not found');
                    }
                } else {
                    throw new ErrorResponse(99998, 'Data not found');
                }
            }
            return response;           
        } catch (error) {
            throw error;
        }
    }
}
