import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn,BeforeInsert, BeforeUpdate} from "typeorm";
import { UserEntity } from "../user/user.entity";
import { IdeaEntity } from "./idea.entity";

@Entity('idea_activity')
export class IdeaActivityEntity { 

  @PrimaryGeneratedColumn('increment',{name:'id'}) 
  Id: number;    
  @Column({
    type: 'int',
    nullable:false,
    name: 'idea_id'
  })
  ideaId: number;
  @Column({
    type: 'int',
    nullable:false,
    name: 'user_id'
  })
  userId: number;
  @Column("boolean",{
    nullable: false,
    name:"liked"
  })
  like:boolean;
  @CreateDateColumn({
    name: "created_at",
    type:"datetime"
  })
  createdAt: Date;
  @VersionColumn({
    default:1,
    name: "version_flag"
})
versionFlag: number;
  @ManyToOne(() =>IdeaEntity,(idea:IdeaEntity)=>idea.ideactivity)
  @JoinColumn({name:"idea_id"})
  idea:IdeaEntity;
  @ManyToOne(() =>UserEntity,(user:UserEntity)=>user.ideactivity)
  @JoinColumn({name:"user_id"})
  user:UserEntity;
   
}