import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn,BeforeInsert, BeforeUpdate} from "typeorm";
@Entity('livetv')
export class LivetvEntity {

    @PrimaryGeneratedColumn('increment',{name:'id'}) Id: number;
    @Column({
        type: 'varchar',
        nullable: false,
        length: '500',
        name: 'livetv_title',
    })
    livetvTitle: string;
    @Column({
        type: 'varchar',
        nullable: false,
        length: '500',
        name: 'livetv_message',
    })
    livetvMessage: string;
    @Column({
        type: 'varchar',
        nullable: false,
        length: '500',
        name: 'livetv_url',
    })
    livetvUrl: string;  
    @Column({
        type: 'varchar',
        nullable: false,
        length: '500',
        name: 'livetv_thumbnail',
    })
    livetvThumbnail: string; 
    @Column({
        type:'int',
        nullable:false,
        default:0,
        name:'is_active'
    })
    isActive:number;
    @Column("boolean",{
        nullable:false,
        default:true,               
        name:"status"
    })
    status:boolean;
    @CreateDateColumn({
        name: "created_at",
        type:"datetime"
    })
    createdAt: Date;
    @Column("int", {
        nullable: true,
        name: "created_user"
    })
    createdUser: number | null;
    @UpdateDateColumn({
        name: "updated_at",
        type:'datetime'
    })
    updatedAt: Date;
    @Column("int", {
        nullable: true,
        name: "updated_user"
    })
    updatedUser: number | null;
    @VersionColumn({
        default:1,
        name: "version_flag"
    })
    versionFlag: number;
}