import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn, In} from "typeorm";
import { DistrictEntity } from "../district/district.entity";
import { StatesEntity } from "../states/states.entity";
import { VillageEntity } from "../village/village.entity";
@Entity('mandal')
export class MandalEntity{

    @PrimaryGeneratedColumn("increment",{name:'id'})
    Id:number;
    @Column("char",{
        nullable:true,
        name:"mandal_code"
    })
    @Index({unique:true})
    mandalCode:string;
    @Column("varchar",{
        nullable:false,
        length:500,
        name:"mandal_name"
    })
    mandalName:string;
    @Column("int",{
        nullable:false,
        name:"district_id"
    })
    districtId: number;
    // @Column("int",{
    //     nullable:true,
    //     name:"state_id"
    // })
    // stateId: number;
    @Column("boolean",{
        nullable:false,
        default:true,
        name:"status"
    })
    status:boolean;
    @CreateDateColumn({
        name: "created_at",
        type:"datetime"
    })
    createdAt:Date ;
    @Column("int",{
        nullable: false,
        name: "created_user"
    })
    createdUser: number | null;
    @UpdateDateColumn({
        name: "updated_at",
        type:'datetime'
    })
    updatedAt:Date;
    @Column("int",{
        nullable:true,
        name: "updated_user"
    })
    updatedUser: number| null;
    @VersionColumn({
        default:1,
        name: "version_flag"
    })
    versionFlag: number;

    @ManyToOne(() => DistrictEntity, (district: DistrictEntity) => district.mandal)
    @JoinColumn({ name: 'district_id'})
    district: DistrictEntity;    
    // @ManyToOne(() => StatesEntity,(states: StatesEntity) => states.mandal)
    // @JoinColumn({name : 'state_id'})
    // states: StatesEntity;
    @OneToMany(() => VillageEntity,(village: VillageEntity) => village.mandal )
    village: VillageEntity;
}


