import { Column, CreateDateColumn, Entity, JoinColumn, ManyToOne, PrimaryGeneratedColumn, UpdateDateColumn, VersionColumn } from "typeorm";
import { PostEntity } from "../post/post.entity";
import { UserEntity } from "../user/user.entity";
import { PollEntity } from "./poll.entity";

@Entity('poll_voting')

export class PollVotingEntity {
    @PrimaryGeneratedColumn('increment',{name:'id'}) Id: number;   
    @Column({
        type: 'int',
        nullable: false,
        name: 'post_id',
    })
    postId: number;
    @Column({
        type:'int',
        nullable:false,
        name:'user_id'
    })
    userId: number;
    @Column({
        type:'int',
        nullable:false,
        name:'poll_id'
    })
    pollId: number;
    @Column("boolean",{
        nullable:false,
        default:true,               
        name:"status"
    })
    status:boolean;
    @CreateDateColumn({
        name: "created_at",
        type:"datetime"
    })
    createdAt: Date;
    @UpdateDateColumn({
        name: "updated_at",
        type:'datetime'
    })
    updatedAt: Date;
    @VersionColumn({
        default:1,
        name: "version_flag"
    })
    versionFlag: number;
    @ManyToOne(() => PostEntity, (post: PostEntity) => post.pollvoting)
    @JoinColumn({ name:'post_id'})
    post: PostEntity;

    @ManyToOne(() => UserEntity, (user: UserEntity) => user.pollvoting)
    @JoinColumn({name:'user_id'})
    user: UserEntity;

    @ManyToOne(() => PollEntity, (poll: PollEntity) => poll.pollvoting)
    @JoinColumn({name:'poll_id'})
    poll: PollEntity;
}