import { errorHandler } from '@gtpl/shared-utils/error-messages';
import { Body, Controller, Post, Query, Req } from '@nestjs/common';
import { ApiHeader, ApiQuery, ApiTags } from '@nestjs/swagger';
import { SingleResponseModel } from '../post/dto/post-response-model';
import { PollVotingDto } from './dto/poll.dto';
import { PollService } from './poll.service';

@ApiTags('Poll')
@Controller('poll')
export class PollController {
    constructor (
        private pollService: PollService,
    ){}
    
    @ApiHeader({
        name:'Authorization',
        description:'Authorization token'
    })  
    @Post('/pollVoting')
    @ApiQuery({name:'apiVersion'})
    async pollVoting(@Query() queryParams,@Body() pollvotDto:PollVotingDto,@Req() request:Request): Promise<SingleResponseModel> {
        try {
            return await this.pollService.pollVoting(queryParams,pollvotDto,request);
        } catch (error) {
            return errorHandler(SingleResponseModel, error);
        }
    }
}
