import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn} from "typeorm";
import { PostEntity } from '../post/post.entity';
import { UserEntity } from "../user/user.entity";
import { PollVotingEntity } from "./poll-voting.entity";
@Entity('poll')
export class PollEntity {
  
  @PrimaryGeneratedColumn("increment",{name:'id'})
  Id:number;
  @Column("int",{
    nullable:false,
    name:"post_id"
  })
  postId:number;
  @Column("int",{
    nullable:false,
    name:"user_id"
  })
  userId:number;
  @Column("varchar",{
    nullable: false,
    length:500,
    name:"poll_type"
  })
  pollType:string;
  @Column("varchar",{
    nullable: false,
    length:500,
    name:"poll_value"
  })
  pollValue:string;
  @Column("boolean",{
    nullable:false,
    default:true,               
    name:"status"
  })
  status:boolean;
  @CreateDateColumn({
    name: "created_at",
    type:"datetime"
  })
  createdAt: Date;
  @Column("int", {
    nullable: true,
    name: "created_user"
  })
  createdUser: number | null;
  @UpdateDateColumn({
      name: "updated_at",
      type:'datetime'
  })
  updatedAt: Date;
  @Column("int", {
      nullable: true,
      name: "updated_user"
  })
  updatedUser: number | null;
  @VersionColumn({
    default:1,
    name: "version_flag"
  })
  versionFlag: number;

  @ManyToOne(() => PostEntity, (post: PostEntity) => post.poll)
  @JoinColumn({ name: 'post_id' })
  post: PostEntity;
  @ManyToOne(() => UserEntity, (user: UserEntity) => user.poll)
  @JoinColumn({name: 'user_id'})
  user: UserEntity;
  @OneToMany(() => PollVotingEntity, (pollvoting: PollVotingEntity) => pollvoting.poll)
  pollvoting:PollVotingEntity;

}