import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn,BeforeInsert, BeforeUpdate} from "typeorm";
import { PostEntity } from '../post/post.entity';
import { UserEntity } from "../user/user.entity";
@Entity('post_activity')

export class PostActivityEntity{
   
  @PrimaryGeneratedColumn('increment',{name:'id'}) Id: number;   
  @Column({
    type: 'int',
    nullable: false,
    name: 'post_id',
  })
  postId: number;
  @Column({
    type:'int',
    nullable:false,
    name:'user_id'
  })
  userId: number;
  @Column({
    type:'boolean',
    nullable: true,
    name:'like_status'
  })
  like: boolean | null;
  @Column({
    type:'boolean',
    nullable: true,
    name:'dislike'
  })
  dislike:boolean | null;
  @Column({
    type:'boolean',
    nullable:true,
    name:'fev',
  })
  fev: boolean | null;
  @Column({
    type: 'int',
    nullable: true,
    name: 'shared',
  })
  shared: number;
  @Column("boolean",{
    nullable:false,
    default:true,               
    name:"status"
  })
  status:boolean;
  @CreateDateColumn({
    name: "created_at",
    type:"datetime"
  })
  createdAt: Date;
  @Column("int", {
    nullable: true,
    name: "created_user"
  })
  createdUser: number | null;
  @UpdateDateColumn({
    name: "updated_at",
    type:'datetime'
  })
  updatedAt: Date;
  @Column("int", {
    nullable: true,
    name: "updated_user"
  })
  updatedUser: number | null;
  @VersionColumn({
    default:1,
    name: "version_flag"
  })
  versionFlag: number;
      
  @ManyToOne(() => PostEntity, (post: PostEntity) => post.postactivity)
  @JoinColumn({ name:'post_id'})
  post: PostEntity;

  @ManyToOne(() => UserEntity, (user: UserEntity) => user.postactivity)
  @JoinColumn({name:'user_id'})
  user: UserEntity;
      
}


