import {IsInt, IsEmail, IsString, IsDateString, IsNumber, IsDate,IsAlphanumeric, MaxLength, Matches, IsOptional, IsNotEmpty, ValidateNested, isNotEmpty } from 'class-validator';
import { ApiProperty } from '@nestjs/swagger';

export class PostFilesDTO {

  @ApiProperty()
  @IsOptional()
  Id?: number;
  @ApiProperty()
  @IsNotEmpty({message:"Post id should not be empty"})
  postId:number;
  @ApiProperty()
  @IsNotEmpty({message:"User id should not be empty"})
  userId:number;
  @ApiProperty()
  @IsNotEmpty({message:"FileType should not be empty"})
  fileType:string;
  @ApiProperty()
  @IsNotEmpty({message:"FileURL should not be empty"})
  fileUrl:string;
  @ApiProperty()
  status: boolean;
  createdAt : Date;
  @ApiProperty()
  @IsOptional()
  createdUser : number;
  updatedAt : Date;
  @ApiProperty()
  @IsOptional()
  updatedUser : number;
  @ApiProperty()
  versionFlag : number;
}

