import {IsInt, IsEmail, IsString, IsDateString, IsNumber, IsDate,IsAlphanumeric, MaxLength, Matches, IsOptional, IsNotEmpty, ValidateNested, isNotEmpty } from 'class-validator';
import { ApiProperty } from '@nestjs/swagger';

export class PostTypeDTO {
  @ApiProperty()
  @IsOptional()
  Id?: number;
  @ApiProperty()
  @MaxLength(500,{message:"Post type contains max 500 characters"})
  @IsNotEmpty({message:"Post type should not be empty"})
  @Matches(new RegExp("^[a-zA-Z0-9\\s]+$"),{ message:"Post type should be only alpha numeric" })
  postType:string;
  @ApiProperty()
  status: boolean;
  createdAt : Date;
  @ApiProperty()
  @IsOptional()
  createdUser : number;
  updatedAt : Date;
  @ApiProperty()
  @IsOptional()
  updatedUser : number;
  @ApiProperty()
  versionFlag : number;
}