import { ApiProperty } from "@nestjs/swagger";
import { IsNotEmpty, IsNumber, IsOptional, Matches, MaxLength } from "class-validator";

export class UpdatePostTypeDTO {
    @ApiProperty()
    @IsNotEmpty({message:"Id should not be empty"})
    @IsNumber()
    Id: number;
    @ApiProperty()
    @MaxLength(500,{message:"Post type contains max 500 characters"})
    @IsNotEmpty({message:"Post type should not be empty"})
    @Matches(new RegExp("^[a-zA-Z0-9\\s]+$"),{ message:"Post type should be only alpha numeric" })
    postType:string;
    @ApiProperty()
    status: boolean;
    updatedAt : Date;
    @ApiProperty()
    @IsOptional()
    updatedUser : number;
    @ApiProperty()
    versionFlag : number;
}

export class PostTypeStatusDTO {
    @ApiProperty()
    @IsNotEmpty({message:"Id should not be empty"})
    @IsNumber()
    Id: number;
    @ApiProperty()
    status: boolean;
    updatedAt : Date;
    @ApiProperty()
    @IsOptional()
    updatedUser : number;
}