import {IsInt, IsEmail, IsString, IsDateString, IsNumber, IsDate,IsAlphanumeric, MaxLength, Matches, IsOptional, IsNotEmpty, ValidateNested, isNotEmpty } from 'class-validator';
import { ApiProperty } from '@nestjs/swagger';

export class PostVisibilityDTO {

  @ApiProperty()
  Id?: number;
  @ApiProperty()
  @IsNotEmpty({message:"postid should not be empty"})
  postId:number;
  @ApiProperty()
  @IsNotEmpty({message:"loginid should not be empty"})
  loginId:number;
  @ApiProperty()
  @IsNotEmpty({message:"Shared should not be empty"})
  shared:boolean;
  @ApiProperty()
  status: boolean;
  createdAt : Date;
  @ApiProperty()
  @IsOptional()
  createdUser : number;
  updatedAt : Date;
  @ApiProperty()
  @IsOptional()
  updatedUser : number;
  @ApiProperty()
  versionFlag : number;
}

