import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn} from "typeorm";
@Entity('post_visibility')
export class PostVisibilityEntity {
  
    @PrimaryGeneratedColumn("increment",{name:'id'})
    Id:number;
    @Column("int",{
        nullable: false,   
        name:"post_id"
    })
    postId:number;
    @Column("int",{
        nullable: false,       
        name:"login_id"
    })
    loginId:number;
    @Column("boolean",{
        nullable: false,
        name:"shared"
    })
    shared:number;
    @Column("boolean",{
        nullable:false,
        default:true,               
        name:"status"
    })
    status:boolean;
    @CreateDateColumn({
        name: "created_at",
        type:"datetime"
    })
    createdAt: Date;
    @Column("int", {
        nullable: true,
        name: "created_user"
    })
    createdUser: number | null;
    @UpdateDateColumn({
        name: "updated_at",
        type:'datetime'
    })
    updatedAt: Date;
    @Column("int", {
        nullable: true,
        name: "updated_user"
    })
    updatedUser: number | null;
    @VersionColumn({
        default:1,
        name: "version_flag"
    })
    versionFlag: number;
}