import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn} from "typeorm";
import { PostEntity } from '../post/post.entity';
import { UserEntity } from "../user/user.entity";
@Entity('post_points')
export class PostPointsEntity {  
  @PrimaryGeneratedColumn("increment",{name:'id'})
  Id:number;
  @Column("int",{
    nullable:false,
    name:"post_id"
  })
  postId:number;
  @Column("int",{
    nullable:true,
    name:"user_id"
  })
  userId:number;
  @Column("int",{
    nullable:true,
    name:'action_by'
  })
  actionBy:number;
  @Column("int",{
    nullable: false,
    name:"points"
  })
  points:number;
  @Column("varchar",{
    nullable: false,
    length:500,
    name:"activity"
  })
  activity:string;
  @CreateDateColumn({
    name: "created_at",
    type:"datetime"
  })
  createdAt: Date;
  @VersionColumn({
    default:1,
    name: "version_flag"
  })
  versionFlag: number;

  @ManyToOne(() => PostEntity, (post: PostEntity) => post.postpoints)
  @JoinColumn({ name: 'post_id' })
  post: PostEntity;
  @ManyToOne(() => UserEntity, (user: UserEntity) => user.postpoints)
  @JoinColumn({name: 'user_id'})
  user: UserEntity;
}