import { forwardRef, Module } from '@nestjs/common';
import { PostService } from './post.service';
import { PostController } from './post.controller';
import { TypeOrmModule } from '@nestjs/typeorm';
import { PostEntity } from './post.entity';
import { PostFilesModule } from '../post-files/post-files.module';
import { PollModule } from '../poll/poll.module';
import { ProfileModule } from '../profile/profile.module';
import { PostActivityModule } from '../post-activity/post-activity.module';
import { CommentsModule } from '../comments/comments.module';
import { PollVotingEntity } from '../poll/poll-voting.entity';
import { HierarchyEntity } from '../hierarchy/hierarchy.entity';
import { PostPointsEntity } from './post-points.entity';
import { DevelopmentStatusEntity } from '../developmentpost/developmentpost.entity';
import { UserPointsEntity } from './user-points.entity';
import { UserEntity } from '../user/user.entity';
import { PostCategoryEntity } from './post-category.entity';

@Module({
  imports: [
    TypeOrmModule.forFeature([PostEntity,PollVotingEntity,HierarchyEntity,PostPointsEntity,DevelopmentStatusEntity,UserPointsEntity,UserEntity,PostCategoryEntity]),
    forwardRef(() =>PostFilesModule), forwardRef(()=>PollModule), forwardRef(() =>ProfileModule),
    forwardRef(()=>PostActivityModule), forwardRef(() => CommentsModule)
  ],
  providers: [PostService],
  controllers: [PostController],
  exports:[PostService]
})
export class PostModule {}
