import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn,BeforeInsert, BeforeUpdate} from "typeorm";
import { CommmentsEntity } from "../comments/comments.entity";
import { PostEntity } from "../post/post.entity";
import { UserEntity } from "../user/user.entity";
@Entity('report') 
export class ReportEntity {

    @PrimaryGeneratedColumn('increment',{name:'id'}) 
    Id: number;
    @Column({
        type:'int',
        nullable: true,
        name: 'post_id'
    })
    postId: number;
    @Column({
        type: 'int',
        nullable:true,
        name: 'comment_id'
    })
    commentId: number;
    @Column({
        type: 'int',
        nullable:false,
        name: 'user_id'
    })
    userId: number;
    @Column({
        type: 'varchar',
        length:'500',
        nullable: false,
        name: 'report_message'
    })
    reportMsg: string;
    @Column("boolean",{
        nullable:false,
        default:true,               
        name:"status"
    })
    status:boolean;
    @CreateDateColumn({
        name: "created_at",
        type:"datetime"
    })
    createdAt: Date;
    @Column("int", {
        nullable: true,
        name: "created_user"
    })
    createdUser: number | null;
    @UpdateDateColumn({
        name: "updated_at",
        type:'datetime'
    })
    updatedAt: Date;
    @Column("int", {
        nullable: true,
        name: "updated_user"
    })
    updatedUser: number | null;
    @VersionColumn({
        default:1,
        name: "version_flag"
    })
    versionFlag: number; 

    @ManyToOne(() => PostEntity, (post: PostEntity) => post.report)
    @JoinColumn({ name:"post_id" })
    post: PostEntity;
    @ManyToOne(() => CommmentsEntity, (comments: CommmentsEntity) => comments.report)
    @JoinColumn({ name: "comment_id" })
    comments: CommmentsEntity;
    @ManyToOne(() =>UserEntity,(user:UserEntity)=>user.report)
    @JoinColumn({name:"user_id"})
    user:UserEntity;
}

