import { errorHandler } from '@gtpl/shared-utils/error-messages';
import { Body, Controller, Get, Param, Post, Query, Req } from '@nestjs/common';
import { ApiOperation, ApiParam, ApiQuery, ApiTags } from '@nestjs/swagger';
import { AllRoleActivityByUserResponseModel } from './dto/role-activity-response.module';
import { getroleActivitysDTO } from './dto/role-activity.dto';
import { RoleActivityService } from './role-activity.service';

@ApiTags('RoleActivity')
@Controller('role-activity')
export class RoleActivityController {
    constructor(
        private roleActivityService: RoleActivityService
    ) {}
    
    @Post('/getActivitiesByUserId')
    @ApiOperation({ summary: 'get user name and activities list' })
    @ApiQuery({name:'apiVersion'})
    async getActivitiesByUserId(@Query() queryParams, @Body() getroleactdto:getroleActivitysDTO,@Req() request:Request): Promise<AllRoleActivityByUserResponseModel> {
        try {
            return await this.roleActivityService.getActivitiesByUserId(queryParams, getroleactdto, request);
        } catch (error) {
            return errorHandler(AllRoleActivityByUserResponseModel, error);
        }
    }
}