import { Column, CreateDateColumn, Entity, JoinColumn, ManyToOne, PrimaryGeneratedColumn, UpdateDateColumn, VersionColumn } from "typeorm";
import { ActivityEntity } from "../activity/activity.entity";
import { RolesEntity } from "../roles/roles.entity";

@Entity('role_activity')
export class RoleActivityEntity {

    @PrimaryGeneratedColumn("increment", {name:"id"})
    Id:number;

    @Column("int",{
        nullable: false,
        name:"role_id"
    })
    roleId:number;
    @Column("int",{
        nullable: false,
        name:"activity_id"
    })
    activityId:number;
    @Column("boolean",{
        nullable:false,
        default:true,               
        name:"status"
    })
    status:boolean;
    @CreateDateColumn({
        name: "created_at",
        type:"datetime"
    })
    createdAt: Date;
    @Column("int", {
        nullable: true,
        name: "created_user"
    })
    createdUser: number | null;
    @UpdateDateColumn({
        name: "updated_at",
        type:'datetime'
    })
    updatedAt: Date;
    @Column("int", {
        nullable: true,
        name: "updated_user"
    })
    updatedUser: number | null;
    @VersionColumn({
        default:1,
        name: "version_flag"
    })
    versionFlag: number;
    @ManyToOne(() => RolesEntity, (roles: RolesEntity) => roles.roleActivity)
    @JoinColumn({name:'role_id'})
    roles: RolesEntity;
    @ManyToOne(() => ActivityEntity, (activity: ActivityEntity) => activity.roleActivity)
    @JoinColumn({name:'activity_id'})
    activity: ActivityEntity;
}