import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn} from "typeorm";
import { RoleActivityEntity } from "../role-activity/role-activity.entity";
import { UserEntity } from "../user/user.entity";

@Entity('roles')
export class RolesEntity {
  
  @PrimaryGeneratedColumn("increment",{name:'id'})
  Id:number;
  @Column("varchar",{
    nullable: false,
    length:45,
    name:"role_name"
  })
  roleName:string;
  @Column("int",{
    nullable: false,
    name:"level"
  })
  level:number;
  @Column("boolean",{
    nullable:false,
    default:true,               
    name:"status"
  })
  status:boolean;
  @CreateDateColumn({
    name: "created_at",
    type:"datetime"
  })
  createdAt: Date;
  @Column("int", {
      nullable: true,
      name: "created_user"
  })
  createdUser: number | null;
  @UpdateDateColumn({
      name: "updated_at",
      type:'datetime'
  })
  updatedAt: Date;
  @Column("int", {
      nullable: true,
      name: "updated_user"
  })
  updatedUser: number | null;
  @VersionColumn({
    nullable:false,
    default:1,
    name: "version_flag"
  })
  versionFlag: number;
 
  @OneToMany(() => UserEntity, (user: UserEntity) => user.roles)
  user: UserEntity;
  @OneToMany(() => RoleActivityEntity, (roleActivity: RoleActivityEntity) => roleActivity.roles)
  roleActivity: RoleActivityEntity;  
}