import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn} from "typeorm";
import { DistrictEntity } from "../district/district.entity";
import { MandalEntity } from "../mandal/mandal.entity";
import { VillageEntity } from "../village/village.entity";

@Entity('states')
export class StatesEntity {

  @PrimaryGeneratedColumn("increment",{name:'id'})
  Id:number;
  @Column("char",{
    nullable:false,
    length:5,
    name:"state_code"
  })
  @Index({unique:true})
  stateCode:string;
  @Column("varchar",{
    nullable:false,
    length:500,
    name:"state_name"
  })
  stateName:string;
  @Column("boolean",{
    nullable:false,
    default:true,
    name:"status"
  })
  status:boolean;
  @CreateDateColumn({
    name: "created_at",
    type:"datetime"
  })
  createdAt: Date;
  @Column("int", {
    nullable: false,
    name: "created_user"
  })
  createdUser: number | null;
  @UpdateDateColumn({
    name: "updated_at",
    type:'datetime'
  })
  updatedAt: Date;
  @Column("int", {
    nullable: true,
    name: "updated_user"
  })
  updatedUser: number | null;
  @VersionColumn({
      default:1,
      name: "version_flag"
  })
  versionFlag: number;
  @OneToMany(() => DistrictEntity,(district:DistrictEntity) => district.states)
  district: DistrictEntity;  
  // @OneToMany(() => MandalEntity, (mandal: MandalEntity) => mandal.states)
  // mandal: MandalEntity;
  // @OneToMany(() => VillageEntity,(village: VillageEntity) => village.states)
  // village: VillageEntity; 
}
