import {IsInt, IsEmail, IsString, IsDateString, IsNumber, IsDate,IsAlphanumeric, MaxLength, Matches, IsOptional, IsNotEmpty, ValidateNested } from 'class-validator';
import { ApiProperty } from '@nestjs/swagger';
export class VillageDTO {
  @ApiProperty()
  @IsOptional()
  Id?: number;
  @ApiProperty()
  @MaxLength(500, { message: "Village name allows maximum 500 characters" })
  @IsNotEmpty()
  @Matches(new RegExp("^[a-zA-Z0-9\\s]+$"),{ message:"Village name should be only alpha numeric" })
  villageName: string;
  @ApiProperty()
  mandalId?: number;
  // @ApiProperty()
  // districtId: number;
  // @ApiProperty()
  // stateId: number;
  @ApiProperty()
  status: boolean;
  createdAt : Date;
  @ApiProperty()
  @IsOptional()
  createdUser : number;
  updatedAt : Date;
  @ApiProperty()
  @IsOptional()
  updatedUser : number;
  @ApiProperty()
  versionFlag : number;
}

export class VillageStatusDTO {
  @ApiProperty()
  @IsOptional()
  Id?: number;
  @ApiProperty()
  status: boolean;
  updatedAt : Date;
  @ApiProperty()
  @IsOptional()
  updatedUser : number;
}
export class getmandalDTO {  
  @ApiProperty()
  @IsNotEmpty({message:"mandalId should not be empty"})
  mandalId:number;
  @ApiProperty()
  @IsNotEmpty({message:"place not empty"})
  place:string;
}

export class searchDto {
  @ApiProperty()
  @IsNotEmpty({message:"place not empty"})
  place:string;
}