import { ErrorResponse } from "@gtpl/shared-models/common-models";
import { errorHandler } from "@gtpl/shared-utils/error-messages";
import { Injectable } from "@nestjs/common";
import { InjectRepository } from "@nestjs/typeorm";
import { Repository } from "typeorm";
import { WardsResponseModel } from "./dto/wards-response.model";
import { WardsDto } from "./dto/wards.dto";
import { WardsEntity } from "./wards.entity";

@Injectable()
export class WardsService { 
    constructor (
        @InjectRepository(WardsEntity)
        private readonly wardRepo:Repository<WardsEntity>,
    ){}

    async createNew(sDto: WardsDto, request:Request): Promise<WardsResponseModel> {
        const response = new WardsResponseModel();        
        try {
            const checkExe = await this.wardRepo.findOne();  
            if(checkExe) { 
                throw new ErrorResponse(99998, 'record alredy existed! ')
            }            
            const saveData = await this.wardRepo.save(sDto);
            if(saveData) {
                response.status = true;
                response.data   = saveData;
                response.statusCode = 50000;
                response.internalMessage = 'saved successfully';
                response.intlCode = 11108;
            } else {
                throw new ErrorResponse(99998, 'save failed')
            }            
            return response;
        } catch (error) {
            return errorHandler(WardsResponseModel, error);
        }
    }

    async updateOld(sDto: WardsDto, request:Request): Promise<WardsResponseModel> {
        const response = new WardsResponseModel();        
        try {
            const checkExe = await this.wardRepo.findOne();  
            if(checkExe) {                 
                   const updated = await this.wardRepo.update(sDto.Id, sDto);
                    response.status = true;
                    response.data   = updated;
                    response.statusCode = 50000;
                    response.internalMessage = 'updated successfully';
                    response.intlCode = 11108;
               response.intlCode = 11108;
            } else {
                throw new ErrorResponse(99998, 'update failed')
            }            
            return response;
        } catch (error) {
            return errorHandler(WardsResponseModel, error);
        }
    }

    async getdata():Promise<WardsResponseModel> {
        const response = new WardsResponseModel();
        try {
            const data = await this.wardRepo.find({where:{status:true}});
            if(data) {
                response.status = true;
                response.data   = data;
                response.statusCode = 50000;
                response.internalMessage = 'data retrived successfully';
                response.intlCode = 11108;
            } else { 
                throw new ErrorResponse(99998, 'data not found')
            }            
            return response;           
        } catch (error) {
            return errorHandler(WardsResponseModel, error);
        }
    }
}