import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn} from "typeorm";
import { UserEntity } from "../user/user.entity";
import { WelfareEntity } from "../welfare/welfare.entity";
@Entity('welfarestatus')
export class WelfareStatusEntity{
    @PrimaryGeneratedColumn("increment",{name:'id'})
    Id:number;
  @Column("int",{
    nullable: false,
    name:"welfare_id"
  })
  welfareId:number;
  @Column({
    type: 'int',
    nullable:false,
    name: 'user_id'
})
userId: number;
    @Column("varchar",{
        nullable:false,
        length:45,      
        name:"welfareStatus"
    })
    welfareStatus:string;
    @Column("boolean",{
      nullable:false,
      default:true,               
      name:"status"
  })
  status:boolean;
    @CreateDateColumn({
        name: "created_at",
        type:"datetime"
      })
      createdAt: Date;           
      @VersionColumn({
          default:1,
          name: "version_flag"
      })
      versionFlag: number;

      @OneToOne(() => WelfareEntity, (welfare: WelfareEntity) => welfare.welfarestatus)
      @JoinColumn({ name: 'welfare_id' })
      welfare: WelfareEntity;    
      @ManyToOne(() =>UserEntity,(user:UserEntity)=>user.welfarestatus)
    @JoinColumn({name:"user_id"})
    user:UserEntity;  
}