import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn} from "typeorm";
import { UserEntity } from "../user/user.entity";
import { WelfaretypeEntity } from "../welfaretype/welfaretype.entity";
import { WelfareFilesEntity } from "./welfare-files.entity";
import { WelfareStatusEntity } from "./welfare-status.entity";

@Entity('welfare')
export class WelfareEntity {
  
  @PrimaryGeneratedColumn("increment",{name:'id'})
  Id:number;
  @Column("varchar",{
    nullable:true,
    length:500,
    name:"welfare_text"
  })
  text: string;
  @Column("int",{
    nullable:false,
    name:"welfaretype_id"
  })
  welfaretypeId:number;
  @Column("varchar",{
    nullable:true,
    length:45,
    name:"current_status"
  })
  currentStatus: string;
  @Column("varchar",{
    nullable:true,
    length:45,
    name:"frist_name"
  })
  firstName: string;
  @Column("varchar",{
     nullable:true,
    length:45,
    name:"last_name"
  })
    lastName:string;
    @Column({
      type: 'int',
      nullable:true,
      name: 'user_id'
  })
  userId: number;
    @Column("varchar",{
        nullable:true,
        length:500,
        name:"address"
    })
    address:string;
    @Column("int",{
      nullable:true,
      name:"village_id"
  })
  villageId:number;
  
    @Column("varchar",{
        nullable:true,
        length:45,
        name:"mobile_no"
    })
    mobileNo:string;
    @Column("varchar",{
        nullable:true,
        length:45,
        name:"email_id"
    })
    email:string;
   
    @Column("boolean",{
      nullable:false,
      default:true,               
      name:"status"
  })
  status:boolean;
    @CreateDateColumn({
        name: "created_at",
        type:"datetime"
      })
      createdAt: Date;
      @Column("int", {
        nullable: false,
        name: "created_user"
      })
      createdUser: number | null;
      @UpdateDateColumn({
        name: "updated_at",
        type:'datetime'
      })
      updatedAt: Date;
      @Column("int", {
        nullable: true,
        name: "updated_user"
      })
      updatedUser: number | null;
      @VersionColumn({
          default:1,
          name: "version_flag"
      })
      versionFlag: number;

    @OneToOne(() => WelfareStatusEntity, (welfarestatus: WelfareStatusEntity) => welfarestatus.welfare)
    welfarestatus: WelfareStatusEntity;
    @OneToMany(() =>WelfareFilesEntity, (welfarefiles:WelfareFilesEntity)=>welfarefiles.welfare)
    welfarefiles:WelfareFilesEntity;
      @ManyToOne(()=>WelfaretypeEntity, (welfaretype:WelfaretypeEntity)=>welfaretype.welfare)
    @JoinColumn({name:"welfaretype_id"})
    welfaretype:WelfaretypeEntity;
    @ManyToOne(() =>UserEntity,(user:UserEntity)=>user.welfare)
    @JoinColumn({name:"user_id"})
    user:UserEntity;
}