import {IsInt, IsEmail, IsString, IsDateString, IsNumber, IsDate,IsAlphanumeric, MaxLength, Matches, IsOptional, IsNotEmpty, ValidateNested, isNotEmpty } from 'class-validator';
import { ApiProperty, ApiPropertyOptional } from '@nestjs/swagger';

export class YoutubeDTO {

  @ApiProperty()
  @ApiPropertyOptional()
  Id?: number;
  @ApiProperty()
  @ApiPropertyOptional()
  title?: string;
  @ApiProperty()
  youtubeLink:string;
  @ApiProperty()
  linkType:number;
  @ApiProperty()
  @ApiPropertyOptional()
  status: boolean;
  createdAt : Date;
  @ApiProperty()
  @ApiPropertyOptional()
  createdUser : number;
  updatedAt : Date;
  @ApiProperty()
  @ApiPropertyOptional()
  updatedUser : number;
  @ApiProperty()
  @ApiPropertyOptional()
  versionFlag : number;
}


export class DeleteYoutubeDTO {
  @ApiProperty()
  Id: number;
  @ApiProperty()
  status: boolean;
  updatedAt : Date;
  @ApiProperty()
  @ApiPropertyOptional()
  updatedUser : number;
  @ApiProperty()
  versionFlag : number;
}

export class PaginationDto {
  @ApiProperty()
  apiVersion?:number;
  @ApiProperty()
  skip:number;
}
