import {BaseEntity,Column,Entity,Index,JoinColumn,JoinTable,ManyToMany,ManyToOne,OneToMany,OneToOne,PrimaryColumn,PrimaryGeneratedColumn,RelationId, VersionColumn, UpdateDateColumn, CreateDateColumn,BeforeInsert, BeforeUpdate} from "typeorm";
@Entity('youtube_links')

export class YoutubeEntity {

    @PrimaryGeneratedColumn('increment',{name:'id'}) Id: number;
    @Column({
        type: 'varchar',
        nullable: true,
        length: '500',
        name: 'title',
    })
    title: string;
    @Column({
        type: 'varchar',
        nullable: false,
        length: '500',
        name: 'youtube_link',
    })
    youtubeLink: string;
    @Column({
        type: 'int',
        nullable: false,
        name: 'link_type',
    })
    linkType: number;
    @Column("boolean",{
        nullable:false,
        default:true,               
        name:"status"
    })
    status:boolean;
    @CreateDateColumn({
        name: "created_at",
        type:"datetime"
    })
    createdAt: Date;
    @Column("int", {
        nullable: true,
        name: "created_user"
    })
    createdUser: number | null;
    @UpdateDateColumn({
        name: "updated_at",
        type:'datetime'
    })
    updatedAt: Date;
    @Column("int", {
        nullable: true,
        name: "updated_user"
    })
    updatedUser: number | null;
    @VersionColumn({
        default:1,
        name: "version_flag"
    })
    versionFlag: number;   
}