import {  MasterPoDetailSizeQuantitiesResponse, MoFeaturesResponse } from '@brandix-apps/shared-models/production-planning';

export class QuantitySummaryRespectToFeaturesUtil {
    public getQuantitySummaryForSizeDetails(moDetails: MasterPoDetailSizeQuantitiesResponse[], features: string[]): {[s: string]: MasterPoDetailSizeQuantitiesResponse[]} {
        return moDetails.reduce(
            (objectsByKeyValue: any, currentObject: MasterPoDetailSizeQuantitiesResponse) => {
                const key = {};
                for (const feature of features) {
                    if (currentObject[feature]) {
                        key[feature] = currentObject[feature];
                    }
                }
                const keyStr = JSON.stringify(key);
                objectsByKeyValue[keyStr] = (objectsByKeyValue[keyStr] || []).concat(currentObject);
                return objectsByKeyValue;
            }
       , {} );
    }

    public getFeaturesHeaderForMasterPoDetails(moDetails: MasterPoDetailSizeQuantitiesResponse[], features: string[]): {[s: string]: MasterPoDetailSizeQuantitiesResponse[]} {
        return moDetails.reduce(
            (objectsByKeyValue: any, currentObject: MasterPoDetailSizeQuantitiesResponse) => {
                for (const feature of features) {
                    if (currentObject[feature]) {
                        objectsByKeyValue[feature] = (objectsByKeyValue[feature] || []);
                        if (!objectsByKeyValue[feature].includes(currentObject[feature]))
                        objectsByKeyValue[feature] = (objectsByKeyValue[feature]).concat(currentObject[feature]);
                    }
                }
                return objectsByKeyValue;
            }
       , {} );
    }
}
