export interface EventBusLogger {
    setContext(context: string): void;
    log(message: any, context?: string): any;
    error(message: any, trace?: string, context?: string): any;
    warn(message: any, context?: string): any;
    debug?(message: any, context?: string): any;
    verbose?(message: any, context?: string): any;
    /**
     * Returns a log creator to be used by libraries to log messages 
     */
    logCreator() : (level: string) => (entry: LogEntry) => void;
}

export enum logLevel {
    NOTHING = 0,
    ERROR = 1,
    WARN = 2,
    INFO = 4,
    DEBUG = 5,
}

export interface LogEntry {
    namespace: string
    level: logLevel
    label: string
    log: LoggerEntryContent
}

export interface LoggerEntryContent {
    readonly timestamp: Date
    readonly message: string
    [key: string]: any
}